#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire500eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight5004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight5004xi = {
                1:'-101x-172y-458z',
                2:'-101x-98y-479z',
                3:'-106x-334y-356z',
                4:'-10x-494y-69z',
                5:'-110x-96y-477z',
                6:'-112x-170y-456z',
                7:'-114x-484y-49z',
                8:'-118x-379y-302z',
                9:'-119x-93y-476z',
                10:'-124x-168y-454z',
                11:'-125x-331y-352z',
                12:'-127x-89y-474z',
                13:'-135x-164y-452z',
                14:'-136x-85y-473z',
                15:'-139x-376y-298z',
                16:'-139x-478y-44z',
                17:'-143x-327y-349z',
                18:'-144x-80y-471z',
                19:'-147x-160y-450z',
                20:'-14x-82y-492z',
                21:'-153x-75y-470z',
                22:'-158x-156y-447z',
                23:'-15x-332y-373z',
                24:'-15x-382y-322z',
                25:'-160x-370y-294z',
                26:'-161x-68y-468z',
                27:'-162x-322y-345z',
                28:'-164x-470y-39z',
                29:'-168x-61y-466z',
                30:'-169x-150y-445z',
                31:'-176x-54y-464z',
                32:'-180x-144y-443z',
                33:'-180x-316y-341z',
                34:'-180x-364y-290z',
                35:'-183x-46y-462z',
                36:'-188x-461y-34z',
                37:'-190x-37y-460z',
                38:'-191x-137y-440z',
                39:'-196x-28y-458z',
                40:'-198x-309y-338z',
                41:'-19x-86y-492z',
                42:'-1x-68y-495z',
                43:'-200x-357y-286z',
                44:'-202x-129y-438z',
                45:'-202x-18y-456z',
                46:'-212x-120y-436z',
                47:'-212x-451y-29z',
                48:'-216x-301y-334z',
                49:'-21x-193y-567z',
                50:'-220x-348y-282z',
                51:'-222x-111y-433z',
                52:'-232x-101y-431z',
                53:'-234x-292y-330z',
                54:'-236x-439y-24z',
                55:'-240x-338y-278z',
                56:'-241x-90y-428z',
                57:'-249x-79y-426z',
                58:'-251x-282y-326z',
                59:'-257x-66y-423z',
                60:'-259x-328y-273z',
                61:'-259x-427y-19z',
                62:'-25x-89y-491z',
                63:'-268x-271y-323z',
                64:'-278x-316y-269z',
                65:'-27x-164y-471z',
                66:'-281x-413y-14z',
                67:'-284x-258y-319z',
                68:'-296x-302y-265z',
                69:'-300x-245y-315z',
                70:'-302x-397y-9z',
                71:'-313x-288y-261z',
                72:'-315x-231y-311z',
                73:'-31x-93y-490z',
                74:'-323x-381y-4z',
                75:'-329x-216y-307z',
                76:'-330x-273y-257z',
                77:'-33x-334y-369z',
                78:'-342x-200y-303z',
                79:'-342x-364y0z',
                80:'-346x-257y-252z',
                81:'-355x-183y-299z',
                82:'-35x-383y-318z',
                83:'-361x-240y-248z',
                84:'-367x-165y-295z',
                85:'-36x-167y-469z',
                86:'-36x-494y-64z',
                87:'-375x-222y-244z',
                88:'-378x-147y-291z',
                89:'-388x-128y-287z',
                90:'-388x-203y-239z',
                91:'-38x-95y-489z',
                92:'-397x-108y-283z',
                93:'-400x-184y-235z',
                94:'-405x-88y-279z',
                95:'-411x-67y-275z',
                96:'-412x-163y-230z',
                97:'-417x-46y-270z',
                98:'-422x-142y-226z',
                99:'-431x-120y-221z',
                100:'-439x-98y-217z',
                101:'-45x-98y-488z',
                102:'-46x-170y-467z',
                103:'-4x-73y-494z',
                104:'-51x-336y-366z',
                105:'-52x-99y-487z',
                106:'-56x-384y-314z',
                107:'-57x-171y-465z',
                108:'-60x-101y-485z',
                109:'-62x-492y-59z',
                110:'-67x-173y-464z',
                111:'-68x-101y-484z',
                112:'-69x-336y-363z',
                113:'-76x-102y-483z',
                114:'-77x-384y-310z',
                115:'-78x-173y-462z',
                116:'-84x-101y-482z',
                117:'-88x-335y-359z',
                118:'-88x-489y-54z',
                119:'-89x-173y-460z',
                120:'-93x-100y-480z',
                121:'-97x-382y-306z',
                122:'-9x-78y-493z'}
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire500eight4xi" usage = "target function for charge500eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire500eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE500EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE500EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE500EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE500EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE500EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight5004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE500EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE500EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE500EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight5004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight5004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE500EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE500EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE500EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire500eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  